;**********************************************************************
;	Nzev programu: GENsLCDfinal.asm
;	Procesor:  < PIC 16F84A >
;	Genertor kmitotu,volba kmitotu pomoc tlatek a LCD
;	Krystal 8MHz
;	Vstup:	RB7(pin14 LCD),RB6(13),RB5(12),RB4(11) - data na LCD
;			RA0(E),RA1(RS) - zen LCD
;			RB0(enter),RA2(dolu),RA3(nahoru),RB2(<-),RB3(->) - tlatka
;	Vstup:	RB1	- vstup genertoru
;**********************************************************************

	LIST P=16F84A,	R=DEC
	include<p16F84A.inc>
cykl	EQU		0x0C
Cyk_1	EQU		cykl+1
Cyk_2	EQU		cykl+2
Cyk_21	EQU		cykl+3
regLCD	EQU		cykl+4
MEM_W	EQU		cykl+5
MEM_S	EQU		cykl+6
jedn	EQU		cykl+7
des		EQU		cykl+8
sta		EQU		cykl+9
kurzor	EQU		cykl+10
TM1		EQU		cykl+11
TM2		EQU		cykl+12
TM3		EQU		cykl+13
rad		EQU		cykl+14
GENus1	EQU		cykl+15
GENus2	EQU		cykl+16
jednG	EQU		cykl+17
desG	EQU		cykl+18
staG	EQU		cykl+19
uGenOUT	EQU		cykl+20
mGenOUT	EQU		cykl+21
GENms1	EQU		cykl+22
GENms2	EQU		cykl+23
pomSmycka	EQU	cykl+24
pomKurzor	EQU	cykl+25
#define	E		PORTA,0
#define	RS		PORTA,1

		ORG		0
		GOTO	Start
		ORG		4
		GOTO	INT

;===================================================================
;  Podprogramy
;===================================================================
;-----------------------------------------------------------------------
; 	Trojita smycka pro as 307,6 ms - cekani po stisku klavesy 
T500ms
		MOVLW	7		;nastaveni hrube smycky 
		MOVWF	TM1
		MOVLW	170		;nastaveni stredni smycky
		MOVWF	TM2		
		MOVLW	254		;nastaveni jemne smycky
		MOVWF	TM3
		DECFSZ	TM3,f	;snizi jemnou smycku o 1, nenili 0 vrati se zpet
			GOTO	$-1
		DECFSZ	TM2,f   ;snizi hrubou smycku o 1, nenili 0 vrati se na jemnou
			GOTO	$-5
		DECFSZ	TM1,f
			GOTO	$-9		
		RETURN	
;-------------------------------------------------------------------
;        Dvojita smycka pro dlouhe casy pri inicializaci
;Vztah:Doba pruchodu smyckama[us]=(1/krystal[MHz])*{4*Cyk_2*(Cyk_1-1)}/4
Smycka1					;Zacatek vnejsi smycky1
		DECFSZ	Cyk_1,f	;
		GOTO	Smycka2
		RETURN			;
Smycka2
		DECFSZ	Cyk_2,f	;Zacatek vnitrni smycky2
		GOTO	Smycka2
		MOVFW	Cyk_21	;
		MOVWF	Cyk_2	;!!! Obnoveni hodnoty Smycky2 !!! 
		GOTO	Smycka1
;-------------------------------------------------------------------
;              Jednoducha smycka pro kratke casy
; Vytah: P = X * (3 + N) + 1    P-poet prchod smykou,X-slo v cykl
Smycka
		DECFSZ	cykl,f
		GOTO	Smycka
		RETURN
;-------------------------------------------------------------------
;             Hodnoty pro dvojitou smycku  
T15ms			;Cekani 15ms
		MOVLW	77		;
		MOVWF	Cyk_1	;!!! Hodnota pruchodu vnejsi smyckou1 !!!
		MOVLW	140		;
		MOVWF	Cyk_2	;!!! Hodnota pruchodu vnitrni smyckou2 !!!
		MOVWF	Cyk_21	;
	CALL Smycka1
		RETURN
T4.1ms			;Cekani 4,1ms
		MOVLW	22		;
		MOVWF	Cyk_1	;!!! Hodnota pruchodu vnejsi smyckou1 !!!
		MOVLW	135		;
		MOVWF	Cyk_2	;!!! Hodnota pruchodu vnitrni smyckou2 !!!
		MOVWF	Cyk_21	;
	CALL Smycka1
		RETURN
;-------------------------------------------------------------------
;             Hodnoty pro jednoduchou smycku  << 100us  >>
T100us			;Cekani 100us
		MOVLW	75		;
		MOVWF	cykl
	CALL Smycka
		RETURN
T40us			;Cekani 40us
		MOVLW	27		;
		MOVWF	cykl
	CALL Smycka
		RETURN
;-------------------------------------------------------------------
; procedura INICIALIZACE DISPLEJE A ZADVN PKAZ
;-------------------------------------------------------------------
wr_prikazLCD				;podprogram zapisuje pkazy do LCD 
		BCF		RS
		MOVWF	regLCD
		BSF		E
		MOVFW	regLCD
		ANDLW	B'11110000'
		MOVWF	PORTB
		BCF		E
		SWAPF	regLCD,W
		NOP
		BSF		E
		ANDLW	B'11110000'
		MOVWF	PORTB
		BCF		E
	CALL	T40us
		RETURN
;-------------------------------------------------------------------
wr_znakLCD				;podprogram zapisuje znaky do LCD			
		BSF		RS
		MOVWF	regLCD
		BSF		E
		MOVFW	regLCD
		ANDLW	B'11110000'
		MOVWF	PORTB
		BCF		E
		SWAPF	regLCD,W
		NOP
		BSF		E
		ANDLW	B'11110000'
		MOVWF	PORTB
		BCF		E
	CALL	T40us
		RETURN
;==================================================================
; 						<<< PERUEN >>>
;==================================================================
INT
;		MOVWF	MEM_W			;
;		SWAPF	STATUS,W		;zatek peruen
;		MOVWF	MEM_S			;
;-------
		CALL	T500ms
		BCF		PORTB,1
		MOVLW	0xC3
		MOVWF	kurzor			;posunut kurzoru na udanou polohu
	CALL	wr_prikazLCD		
		MOVLW	B'00001110'		;pkaz na blikn kurzoru
	CALL	wr_prikazLCD
TL								;<<< obsluha tlacitek >>>
		BTFSC		PORTB,2		;rozdlen tlatek
			GOTO	TLvlevo		;vlevo
		BTFSC		PORTB,3
			GOTO	TLvpravo	;vpravo
		BTFSC		PORTB,0
			GOTO	TLenter		;ENTER
		BTFSC		PORTA,3
			GOTO	TLnahoru	;nahoru
		BTFSC		PORTA,2
			GOTO	TLdolu		;dol	
		GOTO		TL
TLvlevo							;Tlatko vlevo
		MOVLW	B'01101101'		;prava kvli mili-sekundm,aby se nezobrazovali sta
		XORWF	rad,W
		BTFSC	STATUS,Z
			GOTO mVlevo

		MOVLW	0xC2			;<<< ochrana preteceni >>>
		XORWF	kurzor,W		;porovnani reg. s 0xC2
		BTFSC	STATUS,Z		;nenili kurzor=0xC2 jde se na inkrementaci
			GOTO	TL

		MOVLW	B'11100100'		;Jsem-li v rozsahu us,pesko se pozice jednotek
		XORWF	rad,W			;
		BTFSC	STATUS,Z		;
			GOTO uVlevo			;

A1		DECF	kurzor,f		;<<< uprava hodnoty >>>registr kurzor - 1
		MOVFW	kurzor
	CALL	wr_prikazLCD
	CALL	T500ms
		GOTO	TL
TLvpravo						;Tlatko vpravo
		MOVLW	0xC5			;<<< ochrana peteen >>>
		XORWF	kurzor,W		;porovnani reg. s 0xC5
		BTFSC	STATUS,Z		;nenili kurzor=0xC5 jde se na inkrementaci
			GOTO	TL

		MOVLW	B'11100100'		;Jsem-li v rozsahu us,pesko se pozice jednotek
		XORWF	rad,W			;protoe v jednotkch us nen genertor schopen pracovat
		BTFSC	STATUS,Z		;
			GOTO uVpravo		;

A2		INCF	kurzor,f		;<<< uprava hodnoty >>>registr kurzor + 1
		MOVFW	kurzor
	CALL	wr_prikazLCD
	CALL	T500ms
		GOTO	TL
;------------------------------
TLnahoru						;rozdlen tlatka nahoru podle polohy kurzoru
		MOVLW	0xC5			;jeli kurzor na pozici d (14) 
		XORWF	kurzor,W
		BTFSC	STATUS,Z
			GOTO	mikro_N
		MOVLW	0xC4			;pozice jednotek (13)
		XORWF	kurzor,W
		BTFSC	STATUS,Z
			GOTO	jedn_N
		MOVLW	0xC3			;pozice destek (12)
		XORWF	kurzor,W
		BTFSC	STATUS,Z
			GOTO	des_N
		MOVLW	0xC2			;pozice stovek (11)
		XORWF	kurzor,W
		BTFSC	STATUS,Z
			GOTO	sta_N
		GOTO	TL
mikro_N
		MOVLW	B'11100100'		;(u)jeli u volba pouita jde se zpt
		XORWF	rad,W
		BTFSC	STATUS,Z
			GOTO	TL
		MOVLW	B'11100100'
		MOVWF	rad				;zobraz mikro na LCD
	CALL	wr_znakLCD
		MOVFW	kurzor
	CALL	wr_prikazLCD

		DECF	kurzor,f		;!!prava jednotek,pi us mus bt v nule
		MOVFW	kurzor			;!!default je na displeji nastaveno ms,
	CALL	wr_prikazLCD		;!!take to sta jenom tady
		MOVLW	48				;!!
		MOVWF	jedn			;!!
	CALL	wr_znakLCD			;!!
		INCF	kurzor,f		;!!
		MOVFW	kurzor			;!!
	CALL	wr_prikazLCD		;!!

	CALL	T500ms
		GOTO	TL
jedn_N
		MOVLW	57
		XORWF	jedn,W
		BTFSC	STATUS,Z
			GOTO	TL
		INCF	jedn,f
		MOVFW	jedn
	CALL	wr_znakLCD
		MOVFW	kurzor
	CALL	wr_prikazLCD
	CALL	T500ms
		GOTO	TL
des_N
		MOVLW	57
		XORWF	des,W
		BTFSC	STATUS,Z
			GOTO	TL
		INCF	des,f
		MOVFW	des
	CALL	wr_znakLCD
		MOVFW	kurzor
	CALL	wr_prikazLCD
	CALL	T500ms
		GOTO	TL
sta_N
		MOVLW	57
		XORWF	sta,W
		BTFSC	STATUS,Z
			GOTO	TL
		INCF	sta,f
		MOVFW	sta
	CALL	wr_znakLCD
		MOVFW	kurzor
	CALL	wr_prikazLCD
	CALL	T500ms
		GOTO	TL
;------------------------------
TLdolu
		MOVLW	0xC5			;jeli kurzor na pozici d (14) 
		XORWF	kurzor,W
		BTFSC	STATUS,Z
			GOTO	mili_D
		MOVLW	0xC4
		XORWF	kurzor,W
		BTFSC	STATUS,Z
			GOTO	jedn_D
		MOVLW	0xC3
		XORWF	kurzor,W
		BTFSC	STATUS,Z
			GOTO	des_D
		MOVLW	0xC2
		XORWF	kurzor,W
		BTFSC	STATUS,Z
			GOTO	sta_D
		GOTO	TL
mili_D
		MOVLW	B'01101101'		;(m) jeli u volba pouita jde se zpt
		XORWF	rad,W
		BTFSC	STATUS,Z
			GOTO	TL
		MOVLW	B'01101101'
		MOVWF	rad				;zobraz mili na LCD
	CALL	wr_znakLCD
		MOVFW	kurzor
	CALL	wr_prikazLCD

		MOVLW	0xC2			;Vynulovn sta pi (ms)
		MOVWF	kurzor			;
	CALL	wr_prikazLCD		;
		MOVLW	48				;
		MOVWF	sta				;
	CALL	wr_znakLCD			;
		MOVLW	0xC5			;
		MOVWF	kurzor			;
	CALL	wr_prikazLCD		;

	CALL	T500ms
		GOTO	TL
jedn_D
		MOVLW	48
		XORWF	jedn,W
		BTFSC	STATUS,Z
			GOTO	TL
		DECF	jedn,f
		MOVFW	jedn
	CALL	wr_znakLCD
		MOVFW	kurzor
	CALL	wr_prikazLCD
	CALL	T500ms
		GOTO	TL
des_D
		MOVLW	48
		XORWF	des,W
		BTFSC	STATUS,Z
			GOTO	TL
		DECF	des,f
		MOVFW	des
	CALL	wr_znakLCD
		MOVFW	kurzor
	CALL	wr_prikazLCD
	CALL	T500ms
		GOTO	TL
sta_D
		MOVLW	48
		XORWF	sta,W
		BTFSC	STATUS,Z
			GOTO	TL
		DECF	sta,f
		MOVFW	sta
	CALL	wr_znakLCD
		MOVFW	kurzor
	CALL	wr_prikazLCD
	CALL	T500ms
		GOTO	TL

mVlevo							;pi ms vynechn pozice sta
		MOVLW	0xC3			;
		XORWF	kurzor,W		;
		BTFSC	STATUS,Z		;
			GOTO	TL			;

uVlevo							;pi us peskoen pozice jednotek
 		MOVLW	0xC5			;
		XORWF	kurzor,W		;
		BTFSC	STATUS,Z		;
			DECF	kurzor,f	;
		GOTO	A1				;
uVpravo							;pi us peskoen pozice jednotek
		MOVLW	0xC3			;
		XORWF	kurzor,W		;
		BTFSC	STATUS,Z		;
			INCF	kurzor,f	;
		GOTO	A2				;
;===================================================
GENmikro						;konen prava us pro vstup do genertoru
		CLRF	uGenOUT
		MOVFW	des
		MOVWF	desG
		MOVLW	48				;48 tam bylo piteno kvli zobrazen
		SUBWF	desG			;na LCD,tak to musm odest,pro destky

		MOVFW	sta
		MOVWF	staG
		MOVLW	48				;48 tam bylo piteno kvli zobrazen
		SUBWF	staG			;na LCD,tak to musm odest,pro stovky
		
		MOVLW	0				;jeli staG=0,jde se rovnou na konec
		XORWF	staG,W
		BTFSC	STATUS,Z
			GOTO	uSoucet
uUprava							;vlastn nsoben deseti
		MOVLW	10
		ADDWF	uGenOUT
		DECFSZ	staG,f
			GOTO uUprava
uSoucet							;konen souet
		MOVFW	desG
		ADDWF	uGenOUT

		MOVLW	0				;jsouli v us sam nuly,jde se zpt na interapt
		XORWF	uGenOUT
		BTFSC	STATUS,Z
			GOTO	INT

		GOTO	uGEN
;==================================================	
GENmili							;konen prava ms
		CLRF	mGenOUT
		MOVFW	jedn
		MOVWF	jednG
		MOVLW	48				;48 tam bylo piteno kvli zobrazen
		SUBWF	jednG			;na LCD,tak to musm odest,pro destky

		MOVFW	des
		MOVWF	desG
		MOVLW	48				;48 tam bylo piteno kvli zobrazen
		SUBWF	desG			;na LCD,tak to musm odest,pro stovky
		
		MOVLW	0				;jeli staG=0,jde se rovnou na konec
		XORWF	desG,W
		BTFSC	STATUS,Z
			GOTO	mSoucet
mUprava							;vlastn nsoben deseti
		MOVLW	10
		ADDWF	mGenOUT
		DECFSZ	desG,f
			GOTO mUprava
mSoucet							;konen souet
		MOVFW	jednG
		ADDWF	mGenOUT

		MOVLW	0				;jsouli v us sam nuly,jde se zpt na interapt
		XORWF	mGenOUT
		BTFSC	STATUS,Z
			GOTO	INT

		GOTO	mGEN
;------------------------------	
TLenter							;Tlatko ENTER
		MOVLW	B'00001100'		;pkaz aby pestal blikat kurzor
	CALL	wr_prikazLCD
		CALL	T500ms			;!!
		BCF		INTCON,INTF		;
		BSF		INTCON,GIE

;prava jedn,des,sta pro genertor
		MOVLW	B'11100100'		;!!
		XORWF	rad,w			;!!
		BTFSC	STATUS,Z		;!!
	CALL	GENmikro			;!!
		MOVLW	B'01101101'		;!!
		XORWF	rad,w			;!!
		BTFSC	STATUS,Z		;!!
	CALL	GENmili				;!!

;===================================================================
;                      Zacatek programu
;===================================================================
Start
		BSF		STATUS,5	;Prepnuti na BUNKU1
		MOVLW	B'00001100'	;<< Nastaven reg. TRISA >>
		MOVWF	TRISA
		MOVLW	B'00001101'	;<< Nastaven reg. TRISB >>
		MOVWF	TRISB
		BCF		STATUS,5	;Vraceni na BUNKU0
		CLRF	PORTB
		CLRF	PORTA
		MOVLW	B'01101101'
		MOVWF	rad
		MOVLW	48
		MOVWF	jedn
		MOVWF	des
		MOVWF	sta
		BCF		E
		BCF		RS
;-------------------------------------------------------------------
;           Inicializace displeje pro 4-bitovou komunikaci
	CALL	T15ms
 		BSF		E			;E do 1
		MOVLW	B'00110000'		;2. 0011 0000, nastaveni funkce
		MOVWF	PORTB
		BCF		E
	CALL	T4.1ms
		BSF		E			;E do 1
		MOVLW	B'00110000'		;3. 0011 0000, nastaveni funkce
		MOVWF	PORTB
		BCF		E
	CALL	T100us
		BSF		E			;E do 1
		MOVLW	B'00110000'		;4. 0011 0000, nastaveni funkce
		MOVWF	PORTB
		BCF		E
	CALL	T40us
		BSF		E
		MOVLW	B'00100000'
		MOVWF	PORTB		;5. 0010 0000, nastaveni funkce
		BCF		E			;Zapis do dislpleje
	CALL	T40us
;-----------------------
		MOVLW	B'00101000'	;6. 0010 1000, nastaveni funkce
	CALL	wr_prikazLCD
		MOVLW	B'00001000'	;7. 0000 1000, 
	CALL	wr_prikazLCD
		MOVLW	B'00000001'	;8. 0000 0001, Clear display
	CALL	wr_prikazLCD
	CALL	T4.1ms			;<!!! Tady mus bt tadytaasov smyka, jinak to nabh !!!>
		MOVLW	B'00000110'	;9. 0000 0110, Vloz nastaveni modu
	CALL	wr_prikazLCD
		MOVLW	B'00010100'	;   0001 0100,Posun kurzoru/displ
	CALL	wr_prikazLCD
		MOVLW	B'00001100'	;   0000 1100, Displej ON/OFF
	CALL	wr_prikazLCD
;===================================================================
;                       zapis znaku na displej
;===================================================================
		MOVLW	0x80		;pkaz pesune kurzor na 1 znak
	CALL	wr_prikazLCD
		MOVLW	B'01010000'	;P
	CALL	wr_znakLCD
		MOVLW	B'01100101'	;e
	CALL	wr_znakLCD
		MOVLW	B'01110010'	;r
	CALL	wr_znakLCD
		MOVLW	B'01101001'	;i
	CALL	wr_znakLCD
		MOVLW	B'01101111'	;o
	CALL	wr_znakLCD
		MOVLW	B'01100100'	;d
	CALL	wr_znakLCD
		MOVLW	B'01100001'	;a
	CALL	wr_znakLCD
		MOVLW	B'00100000'	;
	CALL	wr_znakLCD
		MOVLW	0xC0		;pkaz pesune kurzor na 9 znak
	CALL	wr_prikazLCD
		MOVLW	B'01110100'	;t
	CALL	wr_znakLCD
		MOVLW	B'00111101'	;=
	CALL	wr_znakLCD
		MOVLW	B'00110000'	;0
	CALL	wr_znakLCD
		MOVLW	B'00110000'	;0
	CALL	wr_znakLCD
		MOVLW	B'00110000'	;0
	CALL	wr_znakLCD
		MOVLW	B'01101101'	;m
	CALL	wr_znakLCD
		MOVLW	B'01110011'	;s
	CALL	wr_znakLCD
;------------------------------------------------------------------
;						<<< PROGRAM >>>
;------------------------------------------------------------------
		MOVLW	B'10111111'
		MOVWF	OPTION_REG
		MOVLW	B'10010000'
		MOVWF	INTCON
		GOTO	$-0
;==================================================================
;	asov smyka pro mikro-sekundy -> 5us
;==================================================================
uGEN
	MOVFW	uGenOUT
	MOVWF	GENus1
	
T5us1					;5us
	MOVFW	GENus1		;hodnota smycky ukladana do GENus2
	MOVWF	GENus2
	GOTO  	skok1
ZAS1
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
skok1
	NOP
	DECFSZ	GENus2,f		;dekrementace
		GOTO	ZAS1		;neni li TM1=0 pokracuje se ve smycce
	BSF		PORTB,1
	NOP
	NOP
T5us0						;5us
	MOVFW	GENus1			;hodnota smycky ukladana do GENus2
	MOVWF	GENus2
	GOTO 	skok0
ZAS0
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
skok0
	NOP			
	DECFSZ	GENus2,f		;dekrementace
		GOTO	ZAS0		;neni li TM1=0 pokracuje se ve smycce
	BCF		PORTB,1
	GOTO	T5us1


;==================================================================
;	asov smyka pro mili-sekundy -> 0.5ms
;==================================================================
mGEN
	MOVFW	mGenOUT
	MOVWF	GENms1
	
T05ms						;0,5ms
	MOVFW	GENms1			;hodnota smycky ukladana do GENms2
	MOVWF	GENms2
	GOTO	mSkok
mZAS
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
mSkok	
	MOVLW	164
	MOVWF	pomSmycka
	NOP
	NOP
pom
	NOP
	NOP
	NOP
	DECFSZ	pomSmycka
		GOTO pom	
	DECFSZ	GENms2,f		;dekrementace
	GOTO	mZAS			;neni li GENms2=0 pokracuje se ve smycce

	BTFSS	PORTB,1
		GOTO	mJedna
	GOTO	mNula
;==================================================================
mJedna
	NOP						;Kvli asovmu sladn "jedna" a "nula" 	
	BSF		PORTB,1
	GOTO	T05ms
mNula
	BCF		PORTB,1
	GOTO	T05ms
END

